package com.yuandian.dataflow;

 
import java.io.File;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.boot.SpringApplication;
import org.springframework.boot.SpringBootConfiguration;
import org.springframework.boot.autoconfigure.SpringBootApplication;

import com.alipay.remoting.serialization.SerializerManager;
import com.alipay.sofa.jraft.JRaftUtils;
import com.alipay.sofa.jraft.Node;
import com.alipay.sofa.jraft.RaftGroupService;
import com.alipay.sofa.jraft.conf.Configuration;
import com.alipay.sofa.jraft.entity.PeerId;
import com.alipay.sofa.jraft.option.NodeOptions;
import com.yuandian.dataflow.statemachine.SyncDataClosure;
import com.yuandian.dataflow.statemachine.StateMachine;
import com.yuandian.dataflow.statemachine.StateServerFactory;
import com.yuandian.dataflow.statemachine.rpc.SyncDataProcessor;

import lombok.var;
import lombok.extern.slf4j.Slf4j;

 


/**
 * Hello world!
 *
 */
@Slf4j
@SpringBootApplication
@SpringBootConfiguration
public class Server {
 
    public static void main(String[] args) throws Exception {
    



        String[] peers = new String[]{"localhost:4440","localhost:4441","localhost:4442"};
        String[] sprPeers = new String[]{"3440","3441","3442"};

        var peeridstr = peers[ Integer.parseInt(args[0] )];
        var sprPort = sprPeers[Integer.parseInt(args[0] )];


        // var peeridstr = peers[2];
        // var sprPort = sprPeers[2];


        Configuration conf = JRaftUtils.getConfiguration("localhost:4440,localhost:4441,localhost:4442");
   
        StateServerFactory.InitStateServer(peeridstr, conf);

        // Thread printer = new Thread( new Runnable(){

        //     @Override
        //     public void run() {
        //         // TODO Auto-generated method stub
        //         while(true) {
        //             var state = StateServerFactory.getStateServer().getFsm().getState();
        //             log.info("{}", state);
        //             try {
        //                 Thread.sleep(1000);
        //             } catch (InterruptedException e) {
        //                 // TODO Auto-generated catch block
        //                 e.printStackTrace();
        //             }
        //         }
        //     }

        // } );
 
        // printer.start();
        
        
        System.setProperty("server.port", sprPort);
        var app = SpringApplication.run(Server.class, args);
        app.start();

        
    }
}
